/*
 * Created on 2004/10/03
 * Author aki@www.xucker.jpn.org
 * License Apache2.0 or Common Public License
 */
package org.jpn.xucker.commons.audio.word;

import java.util.List;
import java.util.Vector;

/**
 * 
 *  
 */
public class MutchWordPlaySystem {

    List playerList = new Vector();

    public MutchWordPlaySystem(WordPlayer[] players) {

        for (int i = 0; i < players.length; i++) {
            addWordAudioPlayer(players[i]);
        }
    }

    public void addWordAudioPlayer(WordPlayer player) {
        playerList.add(player);
    }

    public boolean exist(String word) {
        if (word.length() == 0)
            return false;
        WordPlayer[] players = null;
        synchronized (this) {
            players = (WordPlayer[]) playerList
                    .toArray(new WordPlayer[playerList.size()]);
        }

        for (int i = 0; i < players.length; i++) {

            if (players[i].exist(word)) {

                return true;
            }
        }
        return false;
    }

    public void play(String word) {
        if (word.length() == 0)
            return;

        WordPlayer[] players = null;
        synchronized (this) {
            players = (WordPlayer[]) playerList
                    .toArray(new WordPlayer[playerList.size()]);
        }
        for (int i = 0; i < players.length; i++) {

            if (players[i].exist(word)) {

                players[i].play(word);
                return;
            }
        }
    }

}