package org.jpn.xucker.commons.swt.ui;

/*
 * Created on 2004/06/27
 * 
 * Author aki@www.xucker.jpn.org License Apache2.0 or Common Public License
 */



import org.eclipse.swt.SWT;
import org.eclipse.swt.dnd.DND;
import org.eclipse.swt.dnd.DropTarget;
import org.eclipse.swt.dnd.FileTransfer;
import org.eclipse.swt.dnd.Transfer;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.KeyListener;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.DirectoryDialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableItem;
import org.jpn.xucker.commons.util.Messages;



public class FileListTable  extends FileStatusChanger implements KeyListener,MouseListener,SelectionListener {
    /**
     * @param shell
     */
    private Menu menu1;

    private MenuItem addfile;

    private MenuItem addfolder;

    private MenuItem separatemenu3;

    private MenuItem deletefile;
    private MenuItem deleteAll;
    
    private Table table;
    private Image fileIcon;
    private Image folderIcon;
    private String[] fileExtension;
    
    
    
    public void setLayoutData(Object object){
        table.setLayoutData(object);
    }
    
    
    public FileListTable(Composite parent, int layout) {
        fileIcon = new Image(Display.getCurrent(), FileListTable.class.getClassLoader()
                .getResourceAsStream(
                        "org/jpn/xucker/commons/resource/file.png")); //$NON-NLS-1$
        folderIcon = new Image(Display.getCurrent(), FileListTable.class.getClassLoader()
                .getResourceAsStream(
                        "org/jpn/xucker/commons/resource/folder.png")); //$NON-NLS-1$
        table=new Table(parent,layout);
        table.addMouseListener(this);
        table.addKeyListener(this);
        menu1 = new Menu(table);
        table.setMenu(menu1);
        addfile = new MenuItem(menu1, SWT.PUSH);
        addfile.setText(Messages.getString("FileListTable.addfile")); //$NON-NLS-1$
        addfile.addSelectionListener(this);
        addfolder = new MenuItem(menu1, SWT.PUSH);
        addfolder.setText(Messages.getString("FileListTable.adddir")); //$NON-NLS-1$
        addfolder.addSelectionListener(this);
        separatemenu3 = new MenuItem(menu1, SWT.SEPARATOR);
        deletefile = new MenuItem(menu1, SWT.PUSH);
        deletefile.setText(Messages.getString("FileListTable.delete_selection")); //$NON-NLS-1$
        deletefile.addSelectionListener(this);
        MenuItem item=new MenuItem(menu1,SWT.SEPARATOR);
        item.setText("");//dummy for pmd //$NON-NLS-1$
        deleteAll = new MenuItem(menu1, SWT.PUSH);
        deleteAll.setText(Messages.getString("FileListTable.deleteall")); //$NON-NLS-1$
        deleteAll.addSelectionListener(this);
        
        
        Transfer[] types = new Transfer[] {FileTransfer.getInstance()};
    	
    	int operations = DND.DROP_MOVE | DND.DROP_COPY ;
    	
    	
    		
    	
    	
    	
    	
    		DropTarget target2 = new DropTarget (table, operations);
    		target2.setTransfer(types);
    	
    		target2.addDropListener(new DropMonitor());
    }

    
    public void widgetSelected(SelectionEvent event) {
        Object target = event.getSource();
        if (target == menu1) {
            do_menu1();
        }
        //    addfile
        else if (target == addfile) {
            execAddFile();
        }
        //    addfolder
        else if (target == addfolder) {
            execAddFolder();
        }
        //    deletefile
        else if (target == deletefile) {
            execDeleteFile();
        }else if (target == deleteAll) {
            execDeleteAll();
        }

    }

    public void widgetDefaultSelected(SelectionEvent arg0) {
        
    }

    //null1
    public void do_menu1() {
        System.out.println("menu1"); //$NON-NLS-1$
    }

    //    addfile
    public void execAddFile() {
        FileDialog dialog=new FileDialog(table.getShell(),SWT.OPEN);
        if(fileExtension!=null){
            String extensions[]=new String[fileExtension.length];
            for (int i = 0; i < extensions.length; i++) {
                extensions[i]="*."+fileExtension[i]; //$NON-NLS-1$
            }
            dialog.setFilterExtensions(extensions);
        }
        
        String file=dialog.open();
        if(file!=null){
            addFilePath(file);
        }
    }

    //    addfolder
    public void execAddFolder() {
        DirectoryDialog dialog=new DirectoryDialog(table.getShell(),SWT.OPEN);
        String file=dialog.open();
        if(file!=null){
           addDirectoryPath(file);
        }
    }

    //    deletefile
    public void execDeleteFile() {
        int selection=table.getSelectionIndex();
        if(selection!=-1){
            String path=table.getItem(selection).getText();
            table.remove(selection);
            
            fireRemoveFile(path);
        }
    }
    
    public  void execDeleteAll() {
        int size=table.getItemCount();
        for(int i=size-1;i>=0;i--){
            String path=table.getItem(i).getText();
            table.remove(i);
            
            fireRemoveFile(path);
        }
        
        
    }

    public Table getTable() {
        return table;
    }
    public void setTable(Table table) {
        this.table = table;
    }
    

    public void setFileListText(String text) {
        if(text!=null&&text.length()>0){
            String path[]=text.split(";"); //$NON-NLS-1$
            for(int i=0;i<path.length;i++){
                addDragAndDropFile(path[i]);
            }
        }
    }
    
   
    public String[] getFiles(){
        String result[]=new String[table.getItemCount()];
        for (int i = 0; i < result.length; i++) {
            result[i]=table.getItem(i).getText();
        }
        return result;
    }
   

    /**
     * @return
     */
    public int getFileCount() {
        // TODO Auto-generated method stub
        return table.getItemCount();
    }

    /**
     * @param string
     */
   

    /**
     * @return
     */
    public String getFileListText() {
      String fileList[]=getFiles();
      String result=""; //$NON-NLS-1$
      for (int i = 0; i < fileList.length; i++) {
        result+=fileList[i];
        if(i!=fileList.length-1){
            result+=";"; //$NON-NLS-1$
        }
    }
      return result;
    }

    /**
     * @param path
     */
    protected void addFilePath(String path) {
        if(fileExtension!=null){
        for(int i=0;i<fileExtension.length;i++){
        if(path.toLowerCase().endsWith(fileExtension[i])){
        
            TableItem item=new TableItem(table,SWT.NULL);
            item.setText(path);
            item.setImage(fileIcon);
            break;
        }
        }
        }else{
            TableItem item=new TableItem(table,SWT.NULL);
            item.setText(path);
            item.setImage(fileIcon);
        }
        fireAddFile(path);
    }

    /**
     * @param path
     */
    protected void addDirectoryPath(String path) {
        TableItem item=new TableItem(table,SWT.NULL);
        item.setText(path);
        item.setImage(folderIcon);
        fireAddFile(path);
    }

    /* (non-Javadoc)
     * @see org.eclipse.swt.events.MouseListener#mouseDoubleClick(org.eclipse.swt.events.MouseEvent)
     */
    public void mouseDoubleClick(MouseEvent arg0) {
        
    }

    /* (non-Javadoc)
     * @see org.eclipse.swt.events.MouseListener#mouseDown(org.eclipse.swt.events.MouseEvent)
     */
    public void mouseDown(MouseEvent event) {
        if(event.button==1){
            TableItem item=table.getItem(new Point(event.x,event.y));
            if(item==null){
                table.setSelection(-1);
            }
        }
        if(event.button==3){
             if(table.getSelectionIndex()==-1){
                deletefile.setEnabled(false);
            }else{
                deletefile.setEnabled(true);
            }
        }
    }

    /* (non-Javadoc)
     * @see org.eclipse.swt.events.MouseListener#mouseUp(org.eclipse.swt.events.MouseEvent)
     */
    public void mouseUp(MouseEvent arg0) {
        
    }

    /* (non-Javadoc)
     * @see org.eclipse.swt.events.KeyListener#keyPressed(org.eclipse.swt.events.KeyEvent)
     */
    public void keyPressed(KeyEvent arg0) {
        // TODO Auto-generated method stub
        
    }

    /* (non-Javadoc)
     * @see org.eclipse.swt.events.KeyListener#keyReleased(org.eclipse.swt.events.KeyEvent)
     */
    public void keyReleased(KeyEvent event) {
        if(event.keyCode==127){
            execDeleteFile();
        }
       
    }
    
  
    public String[] getFileExtension() {
        return fileExtension;
    }
    public void setFileExtension(String[] fileExtension) {
        this.fileExtension = fileExtension;
    }
}

